#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
# 
# Module Name:
#   
#     Sequence.tcl
#     
# Abstract:
# 
#     Implementation for EMS test case sequence functions
#

if {[info exist SEQUENCE_TCL] == 1} {
  return
}
set SEQUENCE_TCL 1

# 
# Routine Description:
# 
#   The callback funnction of loading a sequence file
# 
# Arguments:
# 
#   None
# 
# Returns:
# 
#   None.
# 
proc CmdLoadSequence {} {
  global EmsActiveLeftFrame

  if {[EmsWaitForMutex] == -1} {
    return
  }
  switch $EmsActiveLeftFrame {
    "RemoteExecution"    {LoadRemoteExecutionSequence}
    "RemoteValidation"   {LoadRemoteValidationSequence}
  }
  EmsReleaseMutex
}

# 
# Routine Description:
# 
#   The callback function of Saving a sequence file
# 
# Arguments:
# 
#   Root - The root of test case
# 
# Returns:
# 
#   None.
# 
proc CmdSaveSequence {{Root "RemoteExecution"}} {
  global EmsActiveLeftFrame
  if {[EmsWaitForMutex] == -1} {
    return
  }
  switch $EmsActiveLeftFrame {
    "RemoteExecution"    {SaveRemoteExecutionSequence}
    "RemoteValidation"   {SaveRemoteValidationSequence}
  }
  EmsReleaseMutex
}

