#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
################################################################################
CaseLevel         CONFORMANCE
CaseAttribute     AUTO
CaseVerboseLevel  DEFAULT
set reportfile    report.csv

#
# test case Name, category, description, GUID...
#
CaseGuid        0040C121-4104-48cf-99B6-B61C9207B00A
CaseName        CreateChild.Conf1.Case2
CaseCategory    MTFTP4
CaseDescription {This case is to test the EFI_INVALID_PARAMETER Conformance of \
	               Mtftp4SB.CreateChild with ChildHandle being NULL.}
################################################################################

#
# Begin log ...
#
BeginLog

Include MTFTP4/include/Mtftp4.inc.tcl

BeginScope _MTFTP4_CREATECHILD_CONFORMANCE1_CASE2_

UINTN                            R_Status

#
# check point
#
Mtftp4ServiceBinding->CreateChild {NULL, &@R_Status}
GetAck
set assert [VerifyReturnStatus R_Status $EFI_INVALID_PARAMETER]
RecordAssertion $assert $Mtftp4CreateChildConfAssertionGuid002                 \
                "Mtftp4SBP.CreateChild - returns EFI_INVALID_PARAMETER with    \
                 NULL ChildHandle."                                            \
                "ReturnStatus - $R_Status, ExpectedStatus - $EFI_INVALID_PARAMETER"

EndScope _MTFTP4_CREATECHILD_CONFORMANCE1_CASE2_

#
# End Log
#
EndLog