/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsPktCcb.c
    
Abstract:

    

--*/

#include "EmsPktCcb.h"

VOID_P
EmsCcbCreateTcls (
  Tcl_Interp *Interp,
  IN CONST INT8       *Name,
  CCB        *Ccb
  )
/*++

Routine Description:

  Create corresponding TCL variables accroding to CCB

Arguments:

  Interp      - TCL intepreter.
  Name    - The name of variable
  Ccb     - CCB context.

Returns:

  None

--*/
{
  INT8    VarName[100];
  UINT32  Index;

  for (Index = 0; CcbFields[Index].Name; Index++) {
    sprintf (VarName, "%s.%s", Name, CcbFields[Index].Name);
    Tcl_UnlinkVar (Interp, VarName);
    Tcl_LinkVar (Interp, VarName, (UINT8 *) Ccb + CcbFields[Index].Offset, TCL_LINK_INT);
  }

  return ;
}

VOID_P
EmsCcbDestroyTcls (
  Tcl_Interp       *Interp,
  CONST INT8       *Name
  )
/*++

Routine Description:

  Destroy the corresponding TCL variables accroding to CCB

Arguments:

  Interp      - TCL intepreter.
  Name    - The name of variable

Returns:

  None

--*/
{
  INT8    VarName[100];
  UINT32  Index;

  for (Index = 0; CcbFields[Index].Name; Index++) {
    sprintf (VarName, "%s.%s", Name, CcbFields[Index].Name);
    Tcl_UnlinkVar (Interp, VarName);
  }

  return ;
}
