/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  InstallSctSupport.h

Abstract:

  This file provides the support services for the EFI SCT installation.

--*/

#ifndef _EFI_INSTALL_SCT_SUPPORT_H_
#define _EFI_INSTALL_SCT_SUPPORT_H_

#include "Efi.h"

//
// External functions
//

EFI_STATUS
GetFreeSpace (
  IN CHAR16             *FsName,
  OUT UINT64            *FreeSpace
  );

EFI_STATUS
DirFileExist (
  IN CHAR16             *Name,
  OUT BOOLEAN           *Exist
  );

EFI_STATUS
CreateDir (
  IN CHAR16             *DirName
  );

EFI_STATUS
RemoveDirFile (
  IN CHAR16             *Name
  );

EFI_STATUS
BackupDirFile (
  IN CHAR16             *Name
  );

EFI_STATUS
CopyDirFile (
  IN CHAR16             *SrcName,
  IN CHAR16             *DstName,
  IN BOOLEAN            Recursive
  );

#endif
