/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Copyright (c) 2006, Intel Corporation
All rights reserved. 

This UEFI SCT ("Software") is furnished under license and may only be used or copied
in accordance with the terms of that license UEFI Contributor Agreement.
No license, express or implied, by estoppel or otherwise, to any intellectual property
rights is granted by this document. The Software is subject to change without notice,
and should not be construed as a commitment by Intel Corporation to market, license,
sell or support any product or technology. Unless otherwise provided for in the license
under which this Software is provided, the Software is provided AS IS, with no warranties
of any kind, express or implied. Except as expressly permitted by the Software license,
neither Intel Corporation nor its suppliers assumes any responsibility or liability
for any errors or inaccuracies that may appear herein. 

Module Name:

  Ip4ConfigENTSTestCase.c

Abstract:

--*/

#include "Ip4ConfigENTSTestCase.h"

//
// Ip4Config.Start
//
static EFI_EVENT  Ip4ConfigStartDoneEvent;
static EFI_EVENT  Ip4ConfigStartReconfigEvent;
static EFI_STATUS *Ip4ConfigStartStatus;

ENTS_ARG_FIELD    gIp4ConfigStartArgField[] = {
  {
    OCTETN,
    &Ip4ConfigStartDoneEvent
  },
  {
    OCTETN,
    &Ip4ConfigStartReconfigEvent
  },
  {
    POINTER,
    &Ip4ConfigStartStatus
  },
  0
};

EFI_STATUS
Ip4ConfigStart_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  Ip4Config GetModeData Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_IP4_CONFIG_PROTOCOL *Ip4Config;

  Ip4Config = (EFI_IP4_CONFIG_PROTOCOL *) ClientInterface;

  *Ip4ConfigStartStatus = Ip4Config->Start (
                                      Ip4Config,
                                      Ip4ConfigStartDoneEvent,
                                      Ip4ConfigStartReconfigEvent
                                      );
  return EFI_SUCCESS;
}

//
// Ip4Config.Stop
//
static EFI_STATUS *Ip4ConfigStopStatus;

ENTS_ARG_FIELD    gIp4ConfigStopArgField[] = {
  {
    POINTER,
    &Ip4ConfigStopStatus
  },
  0
};

EFI_STATUS
Ip4ConfigStop_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  Ip4Config Stop Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_IP4_CONFIG_PROTOCOL *Ip4Config;

  Ip4Config             = (EFI_IP4_CONFIG_PROTOCOL *) ClientInterface;

  *Ip4ConfigStopStatus  = Ip4Config->Stop (Ip4Config);
  return EFI_SUCCESS;
}

//
// Ip4Config.GetData
//
static UINTN                  *Ip4ConfigGetDataConfigDataSize;
static EFI_IP4_IPCONFIG_DATA  *Ip4ConfigGetDataConfigData;
static EFI_STATUS             *Ip4ConfigGetDataStatus;

ENTS_ARG_FIELD                gIp4ConfigGetDataArgField[] = {
  {
    POINTER,
    &Ip4ConfigGetDataConfigDataSize
  },
  {
    POINTER,
    &Ip4ConfigGetDataConfigData
  },
  {
    POINTER,
    &Ip4ConfigGetDataStatus
  },
  0
};

EFI_STATUS
Ip4ConfigGetData_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  Ip4Config GetData Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  EFI_IP4_CONFIG_PROTOCOL *Ip4Config;

  Ip4Config = (EFI_IP4_CONFIG_PROTOCOL *) ClientInterface;

  *Ip4ConfigGetDataStatus = Ip4Config->GetData (
                                        Ip4Config,
                                        Ip4ConfigGetDataConfigDataSize,
                                        Ip4ConfigGetDataConfigData
                                        );
  return EFI_SUCCESS;
}
