/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  Main.c

Abstract:

  main source file for make pci configuraiton space writable

--*/
#include "Common.h"
#include "Main.h"
#include "EfiShellLib.h"

EFI_DRIVER_ENTRY_POINT (MakeConfigWritableEntryPoint)

EFI_STATUS
MakeConfigWritableEntryPoint (
  IN EFI_HANDLE                      ImageHandle,
  IN EFI_SYSTEM_TABLE                *SystemTable
  )
{
  EFI_STATUS     Status;
  PCIDev         *TestDev;

  //
  //Initialize Libraries
  //
  EFI_SHELL_APP_INIT (ImageHandle, SystemTable);

  Status = FindTestCard (&TestDev);
  if (EFI_ERROR(Status)) {
    Print (L"Not found the Test Card, please insert the Pci Test Card and run this program again.\r\n");
    return Status;
  }

  Status = MakeConfigWritable (TestDev);
  if (EFI_ERROR(Status)) {
    Print (L"Failed make the configuration space writable.\r\n");
  } else {
    Print (L"Successfully make the configuration space writable.\r\n");
  }

  FreePool (TestDev);

  //
  //done successfully
  //
  return EFI_SUCCESS;
}