/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  TapeBBTestMain.h

Abstract:

  Test Driver of TapeIo Protocol

--*/

#ifndef __EFI_TAPE_TEST_H__
#define __EFI_TAPE_TEST_H__


#include "Efi.h"
#include "EfiTest.h"
#include "EfiTypes.h"

#include "EfiTestUtilityLib.h"
#include "EfiDriverLib.h"
#include "EfiTestLib.h"
#include "EfiCommonLib.h"
#include EFI_PROTOCOL_DEFINITION(DebugAssert)

#include EFI_TEST_PROTOCOL_DEFINITION (BBTest)
#include EFI_TEST_PROTOCOL_DEFINITION (StandardTestLibrary)
#include EFI_TEST_PROTOCOL_DEFINITION (TestLoggingLibrary)

#include "TapeGuid.h"
#include "TapeTest.h"


#define TAPE_TEST_REVISION 0x00010000

#define TAPE_FUNCTION_TEST_GUID \
  {0x5f1ad29a, 0x2e9e, 0x4758, 0xa9, 0x6d, 0x9b, 0xbc, 0x28, 0x46, 0xdd, 0x13 }
  

EFI_STATUS
InitializeTapeTest (
  IN EFI_HANDLE           ImageHandle,
  IN EFI_SYSTEM_TABLE     *SystemTable
  );

EFI_STATUS
UnloadTapeTest (
  IN EFI_HANDLE       ImageHandle
  );


EFI_STATUS getStandardLibInterface( EFI_HANDLE SupportHandle );
    
extern void TapeTestWaitForAnyInput ( void );
extern EFI_STATUS getStandardLibInterface( EFI_HANDLE SupportHandle );

extern EFI_STANDARD_TEST_LIBRARY_PROTOCOL   *StandardLib;
extern EFI_TEST_LOGGING_LIBRARY_PROTOCOL	*LoggingLib;

extern EFI_TAPE_IO_PROTOCOL *gTapeIoProtocol;
  

extern VOID
InitializeLib (
  IN EFI_HANDLE           ImageHandle,
  IN EFI_SYSTEM_TABLE     *SystemTable
  );
  
#endif
