/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  SimpleFileSystemProtocol.c

Abstract:

  EFI Simple File System Protocol and EFI_FILE Protocol
    (define according to the EFI Spec, version 1.10)

--*/

#include "Efi.h"

#include "SimpleFileSystemProtocol.h"

//EFI_GUID gEfiSimpleFileSystemProtocolGuid = EFI_SIMPLE_FILE_SYSTEM_PROTOCOL_GUID;

EFI_GUID_STRING(&gEfiSimpleFileSystemProtocolGuid, "Filesystem Protocol", "EFI 1.0 Simple FileSystem Protocol");


//EFI_GUID gEfiFileInfoGuid = EFI_FILE_INFO_ID;

EFI_GUID_STRING(&gEfiFileInfoGuid, "File System Info", "EFI File System Info GUID");


//EFI_GUID gEfiFileInfoIdGuid = EFI_FILE_SYSTEM_INFO_ID;

EFI_GUID_STRING(&gEfiFileInfoIdGuid, "File System Info ID", "EFI File System Info ID GUID");


//EFI_GUID gEfiFileSystemVolumeLabelInfoIdGuid = EFI_FILE_SYSTEM_VOLUME_LABEL_INFO_ID;

EFI_GUID_STRING(&gEfiFileSystemVolumeLabelInfoIdGuid, "File System Vol Label ID", "EFI File System Volume Label Info ID GUID");



