//++
//  Copyright (c) 2008, Intel Corporation
//  All rights reserved. 
// 
//  This UEFI SCT ("Software") is furnished under license and may only be used or copied
//  in accordance with the terms of that license UEFI Contributor Agreement.
//  No license, express or implied, by estoppel or otherwise, to any intellectual property
//  rights is granted by this document. The Software is subject to change without notice,
//  and should not be construed as a commitment by Intel Corporation to market, license,
//  sell or support any product or technology. Unless otherwise provided for in the license
//  under which this Software is provided, the Software is provided AS IS, with no warranties
//  of any kind, express or implied. Except as expressly permitted by the Software license,
//  neither Intel Corporation nor its suppliers assumes any responsibility or liability
//  for any errors or inaccuracies that may appear herein.
//--
;------------------------------------------------------------------------------
;
;
;------------------------------------------------------------------------------

	EXPORT RivlCall
	AREA RivlCallC, CODE, READONLY

;-------------------------------------------------------------------------------------------------------
; UINTN RivlCall (VOID *FuncAddr, UINTN CallingType, UINTN Number, UINTN *StackTop, UINTN *StackBottom);
;-------------------------------------------------------------------------------------------------------

RivlCall
     STMFD sp!, {r4 - r12, lr}
     
     MOV   v1, a1
     MOV   v2, a4
     MOV   v3, a3
     MOV   v4, #0
     LDR   a1, [v2]
     ADD   v2, v2, #4
     LDR   a2, [v2]
     ADD   v2, v2, #4
     LDR   a3, [v2]
     ADD   v2, v2, #4
     LDR   a4, [v2]
     CMP   v3, #0
     BEQ   ready
     CMP   v3, #1
     BEQ   ready
     CMP   v3, #2
     BEQ   ready
     CMP   v3, #3
     BEQ   ready
     CMP   v3, #4
     BEQ   ready

     ;
     ; if arg num > 4, save it in stack
     ;
     ADD   v3, v3, #-4
     MOV   v4, #4
     MUL   v4, v3, v4
     ADD   v2, v2, v4
tostack
     LDR   v4, [v2]
     STR   v4, [sp, #-4]!
     ADD   v3, v3, #-1
     ADD   v2, v2, #-4
     CMP   v3, #0
     BEQ   tostack

ready
     ;BL    v1
     MOV   lr, pc
     MOV   pc, v1

     ADD   sp, sp, v4
     LDMFD sp!, {r4 - r12, pc}

	END
