/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  SctDef.h

Abstract:

  This file defines the global definitions and variables.

--*/

#ifndef _EFI_SCT_DEF_H_
#define _EFI_SCT_DEF_H_

//
// Global definitions
//
#if (EFI_SPECIFICATION_VERSION == 0x0001000A)
#define EFI_SCT_NAME                        L"EFI Self Certification Test"
#elif (EFI_SPECIFICATION_VERSION == 0x00020000)
#define EFI_SCT_NAME                        L"UEFI2.0 Self Certification Test"
#elif (EFI_SPECIFICATION_VERSION == 0x0002000A)
#define EFI_SCT_NAME                        L"UEFI2.1 Self Certification Test"
#endif

#define EFI_SCT_SHORT_NAME                  L"SCT"

//
// The global directory and file names
//

#define EFI_SCT_PATH_DATA                   L"Data"
#define EFI_SCT_PATH_LOG                    L"Log"
#define EFI_SCT_PATH_OVERALL                L"Overall"
#define EFI_SCT_PATH_REPORT                 L"Report"
#define EFI_SCT_PATH_SEQUENCE               L"Sequence"
#define EFI_SCT_PATH_SUPPORT                L"Support"
#define EFI_SCT_PATH_PROXY                  L"Proxy"
#define EFI_SCT_PATH_TEST                   L"Test"

#define EFI_SCT_FILE_LOG                    L"Sct.log"
#define EFI_SCT_FILE_CFG                    L"Sct.cfg"

#define EFI_SCT_FILE_CONFIG                 L"Data\\Config.ini"
#define EFI_SCT_FILE_CATEGORY               L"Data\\Category.ini"
#define EFI_SCT_FILE_GUID_DATABASE          L"Data\\GuidFile.txt"
#define EFI_SCT_FILE_RECOVERY               L"Data\\Recovery.dat"
#define EFI_SCT_FILE_TEST_CASE              L"Data\\TestCase.ini"
#define EFI_SCT_FILE_SKIPPED_CASE           L"Data\\SkippedCase.ini"
#define EFI_SCT_FILE_DEVICE_CONFIG          L"Data\\DeviceConfig.ini"
#define EFI_SCT_SYNC_FILE_CASE_TREE         L"Data\\CaseTree.ini"

#define EFI_SCT_FILE_SUMMARY_LOG            L"Overall\\Summary.log"
#define EFI_SCT_FILE_SUMMARY_EKL            L"Overall\\Summary.ekl"

//
// Maximum buffer size in the SCT
//
#define EFI_SCT_MAX_BUFFER_SIZE             512
#define MAX_STRING_LEN                      250

//
// System hang assertion
//
#define EFI_SYSTEM_HANG_ASSERTION_GUID      \
  { 0xde687a18, 0x0bbd, 0x4396, 0x85, 0x09, 0x49, 0x8f, 0xf2, 0x32, 0x34, 0xf1 }

//
// Global variables
//

extern EFI_SCT_FRAMEWORK_TABLE *gFT;

extern EFI_GUID gEfiSystemHangAssertionGuid;

extern UINTN gTestCaseMaxRunTimeMax;

extern BOOLEAN gForceExecution;
#endif
